"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""

import builtins
import google.protobuf.descriptor
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import google.protobuf.struct_pb2
import sys
import typing

if sys.version_info >= (3, 10):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

class _TenantKind:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _TenantKindEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_TenantKind.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    TENANT_KIND_UNKNOWN: _TenantKind.ValueType  # 0
    TENANT_KIND_ORGANIZATION: _TenantKind.ValueType  # 1
    TENANT_KIND_ACCOUNT: _TenantKind.ValueType  # 2
    """personal tenant"""

class TenantKind(_TenantKind, metaclass=_TenantKindEnumTypeWrapper): ...

TENANT_KIND_UNKNOWN: TenantKind.ValueType  # 0
TENANT_KIND_ORGANIZATION: TenantKind.ValueType  # 1
TENANT_KIND_ACCOUNT: TenantKind.ValueType  # 2
"""personal tenant"""
global___TenantKind = TenantKind

@typing.final
class TenantProperties(google.protobuf.message.Message):
    """Properties of a tenant object"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    KIND_FIELD_NUMBER: builtins.int
    DIRECTORY_V2_FIELD_NUMBER: builtins.int
    DIRECTORY_V2_ONLY_FIELD_NUMBER: builtins.int
    ACCOUNT_FIELD_NUMBER: builtins.int
    kind: global___TenantKind.ValueType
    """The kind of tenant."""
    directory_v2: builtins.bool
    """Whether or not the v2 directory experience enabled for this tenant."""
    directory_v2_only: builtins.bool
    """If true, the tenant cannot be reverted to the v1 directory experience."""
    @property
    def account(self) -> global___AccountProperties:
        """Additional properties that are only set accounts (personal tenant)."""

    def __init__(
        self,
        *,
        kind: global___TenantKind.ValueType = ...,
        directory_v2: builtins.bool = ...,
        directory_v2_only: builtins.bool = ...,
        account: global___AccountProperties | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["_account", b"_account", "account", b"account"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["_account", b"_account", "account", b"account", "directory_v2", b"directory_v2", "directory_v2_only", b"directory_v2_only", "kind", b"kind"]) -> None: ...
    def WhichOneof(self, oneof_group: typing.Literal["_account", b"_account"]) -> typing.Literal["account"] | None: ...

global___TenantProperties = TenantProperties

@typing.final
class AccountProperties(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    MAX_ORGS_FIELD_NUMBER: builtins.int
    GETTING_STARTED_FIELD_NUMBER: builtins.int
    DEFAULT_TENANT_ID_FIELD_NUMBER: builtins.int
    max_orgs: builtins.int
    """Maximum number of organizations that can be created in this account.
    If -1, there is no limit.
    """
    default_tenant_id: builtins.str
    """The default organization for the account"""
    @property
    def getting_started(self) -> global___GuideState:
        """Tracks the account owner's progress through the getting-started guide."""

    def __init__(
        self,
        *,
        max_orgs: builtins.int = ...,
        getting_started: global___GuideState | None = ...,
        default_tenant_id: builtins.str = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["_getting_started", b"_getting_started", "getting_started", b"getting_started"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["_getting_started", b"_getting_started", "default_tenant_id", b"default_tenant_id", "getting_started", b"getting_started", "max_orgs", b"max_orgs"]) -> None: ...
    def WhichOneof(self, oneof_group: typing.Literal["_getting_started", b"_getting_started"]) -> typing.Literal["getting_started"] | None: ...

global___AccountProperties = AccountProperties

@typing.final
class GuideState(google.protobuf.message.Message):
    """The state of a user's progress through the console's getting started guide."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SHOW_FIELD_NUMBER: builtins.int
    STEPS_FIELD_NUMBER: builtins.int
    show: builtins.bool
    """Whether or not to display the getting started guide."""
    @property
    def steps(self) -> google.protobuf.struct_pb2.Struct:
        """Progress information about individual steps in the guide."""

    def __init__(
        self,
        *,
        show: builtins.bool = ...,
        steps: google.protobuf.struct_pb2.Struct | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["steps", b"steps"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["show", b"show", "steps", b"steps"]) -> None: ...

global___GuideState = GuideState
